//+------------------------------------------------------------------+
//|                                                     lbr 3/10.mq4 |
//|                                                           mladen |
//|                                                                  |
//| LBR (Linda Bradford Raschke) group 3/10 indicator                |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1  DeepSkyBlue
#property indicator_color2  Violet
#property indicator_color3  Gray
#property indicator_color4  Violet
#property indicator_color5  DeepSkyBlue
#property indicator_color6  DeepSkyBlue
#property indicator_color7  Magenta
#property indicator_width4  2
#property indicator_width5  2
#property indicator_width6  2
#property indicator_level1  0
#property indicator_levelcolor DimGray

//
//
//
//
//

extern int  FastMA   =  3;
extern int  SlowMA   = 10;
extern int  SignalMA = 16;

int momPeriod = 40;
int bhlPeriod = 20;
int lookBack  =  3;

//
//
//
//
//

double macdBuffer[];
double mahuBuffer[];
double mahdBuffer[];
double signBuffer[];
double siuaBuffer[];
double siubBuffer[];
double dotsBuffer[];
double trndBuffer[][2];


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   SetIndexBuffer(0,mahuBuffer); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,mahdBuffer); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,macdBuffer);
   SetIndexBuffer(3,signBuffer);
   SetIndexBuffer(4,siuaBuffer);
   SetIndexBuffer(5,siubBuffer);
   SetIndexBuffer(6,dotsBuffer); SetIndexStyle(6,DRAW_ARROW); SetIndexArrow(6,108);
   IndicatorShortName("LBR 3/10 ("+FastMA+","+SlowMA+","+SignalMA+")");
   return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{
   int counted_bars=IndicatorCounted();
   int i,r,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (ArrayRange(trndBuffer,0) != Bars) ArrayResize(trndBuffer,Bars);

   //
   //
   //
   //
   //


   if (trndBuffer[Bars-limit-1][1] ==1) CleanPoint(limit,siuaBuffer,siubBuffer);
      for(i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         macdBuffer[i]    = iMA(NULL,0,FastMA,0,MODE_SMA,PRICE_CLOSE,i)-iMA(NULL,0,SlowMA,0,MODE_SMA,PRICE_CLOSE,i);
         mahuBuffer[i]    = EMPTY_VALUE;
         mahdBuffer[i]    = EMPTY_VALUE;
         dotsBuffer[i]    = EMPTY_VALUE;
         siuaBuffer[i]    = EMPTY_VALUE;
         siubBuffer[i]    = EMPTY_VALUE;
         trndBuffer[r][0] = trndBuffer[r-1][0];
         trndBuffer[r][1] = trndBuffer[r-1][1];
      
         //
         //
         //
         //
         //
            
         if (macdBuffer[i] > macdBuffer[i+1]) trndBuffer[r][0] =  1;
         if (macdBuffer[i] < macdBuffer[i+1]) trndBuffer[r][0] = -1;
            if (trndBuffer[r][0] ==  1) mahuBuffer[i] = macdBuffer[i];
            if (trndBuffer[r][0] == -1) mahdBuffer[i] = macdBuffer[i];
            
         //
         //
         //
         //
         //
         
         double avg = 0;
            for (int k=0; k<SignalMA; k++) avg += macdBuffer[i+k];
                                           avg /= SignalMA;
         signBuffer[i] = avg;
         if (signBuffer[i] > signBuffer[i+1]) trndBuffer[r][1] =  1;
         if (signBuffer[i] < signBuffer[i+1]) trndBuffer[r][1] = -1;
            if (trndBuffer[r][1] == 1) PlotPoint(i,siuaBuffer,siubBuffer,signBuffer);
         
         
         //
         //
         //
         //
         //
         
         if ((iHighest(NULL,0,MODE_HIGH,bhlPeriod,i)-i) <= lookBack)
            {
               for (k=1; k<momPeriod; k++) if (macdBuffer[i+k]>macdBuffer[i]) break;
                                           if (k==momPeriod) dotsBuffer[i] = macdBuffer[i];
            }
         if ((iLowest(NULL,0,MODE_LOW,bhlPeriod,i)-i) <= lookBack)
            {
               for (k=1; k<momPeriod; k++) if (macdBuffer[i+k]<macdBuffer[i]) break;
                                           if (k==momPeriod) dotsBuffer[i] = macdBuffer[i];
            }
      }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
      if (first[i+2] == EMPTY_VALUE) {
          first[i]    = from[i];
          first[i+1]  = from[i+1];
          second[i]   = EMPTY_VALUE;
         }
      else {
          second[i]   = from[i];
          second[i+1] = from[i+1];
          first[i]    = EMPTY_VALUE;
         }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}